--------------------------------------------------------------------------------------------------------------------------------------

	-- Fonctions pour tout ce qui touchent aux fichiers txt --

----------------------------------------------------------------------------------------------------------------------------------------

--------------- ! Fonction qui charge toutes les maps contenues dans un txt ! ---------------
function creer_maps(var)
	if (var == 1) then
		file = io.open("scripts_lua/cartes_principales.txt","r")
		niveau_bloque = 0
	else
		niveau_bloque = 0
		file = io.open("carte.txt","r")
	end
	fin_lecture = false
	num_carte = 1
	ind_carte = 0
	all_maps = {}
	all_maps[1] = {num = 0 ; carte = "" ; c = 0 ; l = 0 ; tps = 0 ; rec = 0 ; med = 0}
	
	while (fin_lecture == false) do
		ind_carte = ind_carte + 1
		data = file:read()
		if (data == "fin") then
			fin_lecture = true
		else
			if (var == 1) then
				if (ind_carte == 1) then
					all_maps[num_carte].c = tonumber(data)
				elseif (ind_carte == 2) then
					all_maps[num_carte].rec = tonumber(data)
					if (niveau_bloque == 0) and (all_maps[num_carte].rec == 0) then
						niveau_bloque = num_carte
					end
				elseif (ind_carte == 3) then
					all_maps[num_carte].num = tonumber(data)
				elseif (ind_carte == 4) then
					all_maps[num_carte].med = tonumber(data)
				elseif (ind_carte == 5) then
					all_maps[num_carte].l = tonumber(data)
				elseif (ind_carte == 6) then
					all_maps[num_carte].tps = tonumber(data)
				elseif (ind_carte == 7) then
					all_maps[num_carte].carte = tostring(data)
					num_carte = num_carte + 1
					all_maps[num_carte] = {carte = "" ; c = 0 ; l = 0 ; tps = 0 ; rec = 0 ; med = 0}
					ind_carte = 0
				end
			else
				if (ind_carte == 1) then
					all_maps[num_carte].num = tonumber(data)
				elseif (ind_carte == 2) then
					all_maps[num_carte].carte = tostring(data)
				elseif (ind_carte == 3) then
					all_maps[num_carte].c = tonumber(data)
				elseif (ind_carte == 4) then
					all_maps[num_carte].l = tonumber(data)
				elseif (ind_carte == 5) then
					all_maps[num_carte].tps = tonumber(data)
				elseif (ind_carte == 6) then
					all_maps[num_carte].rec = tonumber(data)
				elseif (ind_carte == 7) then
					all_maps[num_carte].med = tonumber(data)
					num_carte = num_carte + 1
					all_maps[num_carte] = {carte = "" ; c = 0 ; l = 0 ; tps = 0 ; rec = 0 ; med = 0}
					ind_carte = 0
				end
			end
		end
	end
	file:close()
	num_carte = num_carte - 1
	all_maps[table.getn(all_maps)] = nil
	if (niveau_bloque == 0) then
		niveau_bloque = table.getn(all_maps) + 1
	end
end

--------------- ! Fonction qui charge toutes les evenements contenus dans un txt ! ---------------
function creer_events(var)
	if (var == 1) then
		file = io.open("scripts_lua/evenements_principaux.txt","r") 
	else
		file = io.open("evenements.txt","r") 
	end
	fin_lecture = false
	num_event = 1
	ind_event = 0
	all_events = {}
	all_events[1] = {id = 0 ; action = "" ; col = 0 ; lig = 0 ; t_c = 0 ; t_l = 0 ; img = 0 ; couleur = 0}
	while fin_lecture == false do
		ind_event = ind_event + 1
		data = file:read()
		if (data == "fin") then
			fin_lecture = true
		else
			if (var == 1) then
				if (ind_event == 1) then
					all_events[num_event].t_l = tonumber(data)
				elseif (ind_event == 2) then
					all_events[num_event].col = tonumber(data)
				elseif (ind_event == 3) then
					all_events[num_event].img = tonumber(data)
				elseif (ind_event == 4) then
					all_events[num_event].lig = tonumber(data)
				elseif (ind_event == 5) then
					all_events[num_event].t_c = tonumber(data)
				elseif (ind_event == 6) then
					all_events[num_event].action = tostring(data)
				elseif (ind_event == 7) then
					all_events[num_event].couleur = Color.new(tonumber(string.sub(data,2,4)),tonumber(string.sub(data,6,8)),tonumber(string.sub(data,10,12)))
				elseif (ind_event == 8) then
					all_events[num_event].id = tonumber(data)
					num_event = num_event + 1
					all_events[num_event] = {id = 0 ; action = "" ; col = 0 ; lig = 0 ; t_c = 0 ; t_l = 0 ; img = 0 ; couleur = 0}
					ind_event = 0
				end
			else
				if (ind_event == 1) then
					all_events[num_event].id = tonumber(data)
				elseif (ind_event == 2) then
					all_events[num_event].action = tostring(data)
				elseif (ind_event == 3) then
					all_events[num_event].col = tonumber(data)
				elseif (ind_event == 4) then
					all_events[num_event].lig = tonumber(data)
				elseif (ind_event == 5) then
					all_events[num_event].t_c = tonumber(data)
				elseif (ind_event == 6) then
					all_events[num_event].t_l = tonumber(data)
				elseif (ind_event == 7) then
					all_events[num_event].img = tonumber(data)
				elseif (ind_event == 8) then
					all_events[num_event].couleur = Color.new(tonumber(string.sub(data,2,4)),tonumber(string.sub(data,6,8)),tonumber(string.sub(data,10,12)))
					num_event = num_event + 1
					all_events[num_event] = {id = 0 ; action = "" ; col = 0 ; lig = 0 ; t_c = 0 ; t_l = 0 ; img = 0 ; couleur = 0}
					ind_event = 0
				end
			end
		end
	end
	num_event = num_event - 1
	all_events[table.getn(all_events)] = nil
	file:close()
end

--------------- ! Fonction qui sauvegarde les maps & evenements modifis dans un txt ! ---------------
function sauvegarder_partie(var)
	sauvegarde = nil
	sauvegarde = {}
	-- ! On liste les cartes ! --
	if (var == 1) then
		for i = 1,table.getn(all_maps) do
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].c
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].rec
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].num
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].med
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].l
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].tps
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].carte
		end
	else
		for i = 1,table.getn(all_maps) do
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].num
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].carte
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].c
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].l
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].tps
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].rec
			sauvegarde[table.getn(sauvegarde) + 1] = all_maps[i].med
		end
	end
	-- ! On sauvegarde dans un fichier texte ! --
	
	if (var == 1) then
		file = io.open("scripts_lua/cartes_principales.txt","w")
	else
		file = io.open("carte.txt","w")
	end
	for i = 1,table.getn(sauvegarde) do
		file:write(sauvegarde[i].."\n")
	end
	-- ! On crit la balise de fin ! --
	file:write("fin")
	file:close()
end

--------------- ! Fonction qui demande confirmation pour la rinitialisation ! ---------------
function reinitialiser_arcade(var)
	background = Image.load("images/autres/background.png")
	choix_reinit = 0
	oldpad = Controls.read()
	selecteur = 1
	rafraichir = true
	while (choix_reinit == 0) do
		pad = Controls.read()
		if (rafraichir == true) then
			rafraichir = false
			afficher_menu_option(2)
			Gu.start3d()
			IntraFont.load("flash0:/font/ltn8.pgf", 1)
			
			if (var == 1) then
				IntraFont.print((240 - ((IntraFont.print(240,240,"Etes-vous sr de vouloir rinitialiser le mode Arcade?",1,0,0) - 240)/2)),200,"Etes-vous sr de vouloir rinitialiser le mode Arcade?", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			else
				IntraFont.print((240 - ((IntraFont.print(240,240,"Etes-vous sr de vouloir rinitialiser le mode Partie Personnalise?",1,0,0) - 240)/2)),200,"Etes-vous sr de vouloir rinitialiser le mode Partie Personnalise?", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			end
			IntraFont.load("flash0:/font/ltn13.pgf", 1)
			IntraFont.print((240 - ((IntraFont.print(240,240,"(Mdailles et records seront effacs)",1,0,0) - 240)/2)),220,"(Mdailles et records seront effacs)", 1, IntraFont.color(170,170,170,255),IntraFont.color(0,0,0,255))
			if (selecteur == 1) then
				IntraFont.load("flash0:/font/ltn5.pgf", 1)
				IntraFont.print(20,260,"Oui",1,IntraFont.color(255,255,255,255),IntraFont.color(100,100,100,255))
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((460 - (IntraFont.print(0,200,"Non",1,0,0))),260,"Non",1,IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
			else
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print(20,260,"Oui",1,IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
				IntraFont.load("flash0:/font/ltn5.pgf", 1)
				IntraFont.print((460 - (IntraFont.print(0,200,"Non",1,0,0))),260,"Non",1,IntraFont.color(255,255,255,255),IntraFont.color(100,100,100,255))
			end
			
			Gu.end3d()
			screen.waitVblankStart()
			screen:flip()
		end
		if (pad:right() and not oldpad:right()) then
			selecteur = 2
			rafraichir = true
		elseif (pad:left() and not oldpad:left()) then
			selecteur = 1
			rafraichir = true
		elseif (pad:cross() and not oldpad:cross()) then
			choix_reinit = selecteur
		elseif (pad:circle() and not oldpad:circle()) then
			choix_reinit = 2
		end
		oldpad = pad
	end
	if (choix_reinit == 1) then
		background, choix_reinit, oldpad, selecteur, rafraichir = nil
		remise_a_zero(var)
		menu_option(var)
	elseif (choix_reinit == 2) then
		background, choix_reinit, oldpad, selecteur, rafraichir = nil
		menu_option(var)
	end
end

--------------- ! Fonction qui rinitialise les records et medailles des maps ! ---------------
function remise_a_zero(var)
	creer_maps(var)
	creer_events(var)
	if (table.getn(all_maps) > 0) then
		for i = 1,table.getn(all_maps) do
			all_maps[i].rec = 0
			all_maps[i].med = 1
		end
		sauvegarder_partie(var)
	end
end

--------------- ! Fonction qui permet la mise  jour des niveaux du jeu ! ---------------
function mettre_a_jour(var)
	selecteur = menu_maj(var)
	if (selecteur == 1) then
		choix_dl = confir_dl()
		if (choix_dl == true) then
			file = io.open("ms0:/PSP/GAME/cale/maj/telechargement.txt","w")
				file:write("true")
			file:close()
			System.webbrowser("ms0:/psp/game/cale","http://www.dtk.free.fr/psp-cale")
		else
			background,oldpad = nil
			rafraichir = true
			mettre_a_jour(1)
		end
	else
		if (selecteur ~= 4) then
			if (selecteur == 2) then
				mode_maj = 1
				modification = ""
			else
				mode_maj = 2
				modification = ""
			end
			
			choix_confirm = confirmer_maj()
			if (choix_confirm == true) then
				charger_fichiers_maj(mode_maj)
				if (table.getn(tab_maj_carte) > 0) then
					creer_maps(mode_maj)
					creer_events(mode_maj)
					mem_nb_carte_av = table.getn(all_maps)
					ajouter_fichiers()
					if (mem_nb_carte_av ~= table.getn(all_maps)) then
						sauvegarder_maj(mode_maj)
						mess_maj = "Mise  jour russie. Il y'a eu "..table.getn(all_maps)-mem_nb_carte_av.." niveau(x) d'ajout(s)"
					else
						mess_maj = "Cette mise  jour a dj t effectue."
					end
				else
					mess_maj = "Aucune mise  jour possible. (Fichiers vides)"
				end
				
				oldpad = Controls.read()
				fin_aff_maj = false
				rafraichir = true
				while (fin_aff_maj == false) do
					pad = Controls.read()
					if (rafraichir == true) then
						rafraichir = false
						afficher_menu_option(2)
						
						Gu.start3d()
						IntraFont.load("flash0:/font/ltn8.pgf", 1)
						if (modification == "") then
							IntraFont.print((240 - ((IntraFont.print(240,30,"Rsultat de la Mise  Jour",1,0,0) - 240)/2)),200,"Rsultat de la Mise  Jour",1,IntraFont.color(255,255,255,255),IntraFont.color(100,100,100,255))
							IntraFont.load("flash0:/font/ltn13.pgf", 1)
							IntraFont.print((240 - ((IntraFont.print(240,200,"("..mess_maj..")",1,0,0) - 240)/2)),230,"("..mess_maj..")",1,IntraFont.color(170,170,170,255),IntraFont.color(0,0,0,255))
							IntraFont.print((240 - ((IntraFont.print(240,200,"Pressez X pour continuer",1,0,0) - 240)/2)),260,"Pressez X pour continuer",1,IntraFont.color(100,100,100,255),IntraFont.color(100,100,100,0))
						else
							IntraFont.print((240 - ((IntraFont.print(240,30,"Rsultat de la Mise  Jour",1,0,0) - 240)/2)),200,"Rsultat de la Mise  Jour",1,IntraFont.color(255,255,255,255),IntraFont.color(100,100,100,255))
							IntraFont.load("flash0:/font/ltn13.pgf", 1)
							IntraFont.print((240 - ((IntraFont.print(240,200,"("..mess_maj..")",1,0,0) - 240)/2)),225,"("..mess_maj..")",1,IntraFont.color(170,170,170,255),IntraFont.color(0,0,0,255))
							IntraFont.print((240 - ((IntraFont.print(240,200,"(Le(s) niveau(x) "..modification.." a (ont) t modifi(s).)",1,0,0) - 240)/2)),245,"(Le(s) niveau(x) "..modification.." a (ont) t modifi(s).)",1,IntraFont.color(170,170,170,255),IntraFont.color(0,0,0,255))
							IntraFont.print((240 - ((IntraFont.print(240,200,"Pressez X pour continuer",1,0,0) - 240)/2)),270,"Pressez X pour continuer",1,IntraFont.color(100,100,100,255),IntraFont.color(100,100,100,0))
						end
						Gu.end3d()
						
						screen.waitVblankStart()
						screen:flip()
					end
					if (pad:cross() and not oldpad:cross()) then
						fin_aff_maj = true
						background,oldpad,fin_aff_maj = nil
						mettre_a_jour(mode_maj+1)
					end
					
					oldpad = pad
					
				end
			else	
				background,oldpad = nil
				rafraichir = true
				if (mode_maj == 1) then
					mettre_a_jour(2)
				else
					mettre_a_jour(3)
				end
			end
		else
			background,oldpad = nil
			rafraichir = true
			menu_option(3)
		end
	end
end

--------------- ! Fonction qui demande confirmation pour la mise  jour ! ---------------
function confirmer_maj()
	fin_confirm_maj = false
	oldpad = Controls.read()
	rafraichir = true
	selecteur = 1
	background = Image.load("images/autres/background.png")
	while (fin_confirm_maj == false) do
		pad = Controls.read()
		if (rafraichir == true) then
			rafraichir = false
			afficher_menu_option(2)
			Gu.start3d()
			IntraFont.load("flash0:/font/ltn8.pgf", 1)
			if (mode_maj == 1) then
				IntraFont.print((240 - ((IntraFont.print(240,240,"Etes-vous sr de vouloir mettre  jour le mode Arcade?",1,0,0) - 240)/2)),200,"Etes-vous sr de vouloir mettre  jour le mode Arcade?", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			else
				IntraFont.print((240 - ((IntraFont.print(240,240,"Etes-vous sr de vouloir mettre  jour le mode Personnalis?",1,0,0) - 240)/2)),200,"Etes-vous sr de vouloir mettre  jour le mode Personnalis?", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			end
			
			IntraFont.load("flash0:/font/ltn13.pgf", 1)
			IntraFont.print((240 - ((IntraFont.print(240,240,"(Certains chronos pourront tre modifis.)",1,0,0) - 240)/2)),220,"(Certains chronos pourront tre modifis.)", 1, IntraFont.color(170,170,170,255),IntraFont.color(0,0,0,255))
			
			if (selecteur == 1) then
				IntraFont.load("flash0:/font/ltn5.pgf", 1)
				IntraFont.print(20,260,"Oui",1,IntraFont.color(255,255,255,255),IntraFont.color(100,100,100,255))
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((460 - (IntraFont.print(0,200,"Non",1,0,0))),260,"Non",1,IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
			else
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print(20,260,"Oui",1,IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
				IntraFont.load("flash0:/font/ltn5.pgf", 1)
				IntraFont.print((460 - (IntraFont.print(0,200,"Non",1,0,0))),260,"Non",1,IntraFont.color(255,255,255,255),IntraFont.color(100,100,100,255))
			end
			Gu.end3d()
			screen.waitVblankStart()
			screen:flip()
			
		end
		
		if (pad:right() and not oldpad:right()) then
			selecteur = 2
			rafraichir = true
		elseif (pad:left() and not oldpad:left()) then
			selecteur = 1
			rafraichir = true
		elseif (pad:cross() and not oldpad:cross()) then
			fin_confirm_maj = true
		elseif (pad:circle() and not oldpad:circle()) then
			fin_confirm_maj = true
			selecteur = 2
		end
		oldpad = pad
	end
	if (selecteur == 1) then
		return(true)
	else
		return(false)
	end
end

--------------- ! Fonction qui charge les niveaux  ajouter ! ---------------
function charger_fichiers_maj(var)
	if (var == 1) then
		file = io.open("maj/nouvelles_cartes.txt","r")
	else
		file = io.open("maj/carte.txt","r")
	end
	fin_lecture = false
	tab_maj_carte = {}
	ind_carte = 0
	
	while (fin_lecture == false) do
		ind_carte = ind_carte + 1
		data = file:read()
		if (data == "fin") then
			fin_lecture = true
		else
			if (var == 1) then
				if (ind_carte == 1) then
					tab_maj_carte[table.getn(tab_maj_carte)+1] = {}
					tab_maj_carte[table.getn(tab_maj_carte)].c = tonumber(data)
				elseif (ind_carte == 2) then
					tab_maj_carte[table.getn(tab_maj_carte)].rec = tonumber(data)
				elseif (ind_carte == 3) then
					tab_maj_carte[table.getn(tab_maj_carte)].num = tonumber(data)
				elseif (ind_carte == 4) then
					tab_maj_carte[table.getn(tab_maj_carte)].med = tonumber(data)
				elseif (ind_carte == 5) then
					tab_maj_carte[table.getn(tab_maj_carte)].l = tonumber(data)
				elseif (ind_carte == 6) then
					tab_maj_carte[table.getn(tab_maj_carte)].tps = tonumber(data)
				elseif (ind_carte == 7) then
					tab_maj_carte[table.getn(tab_maj_carte)].carte = tostring(data)
					ind_carte = 0
				end
			else
				if (ind_carte == 1) then
					tab_maj_carte[table.getn(tab_maj_carte)+1] = {}
					tab_maj_carte[table.getn(tab_maj_carte)].num = tonumber(data)
				elseif (ind_carte == 2) then
					tab_maj_carte[table.getn(tab_maj_carte)].carte = tostring(data)
				elseif (ind_carte == 3) then
					tab_maj_carte[table.getn(tab_maj_carte)].c = tonumber(data)
				elseif (ind_carte == 4) then
					tab_maj_carte[table.getn(tab_maj_carte)].l = tonumber(data)
				elseif (ind_carte == 5) then
					tab_maj_carte[table.getn(tab_maj_carte)].tps = tonumber(data)
				elseif (ind_carte == 6) then
					tab_maj_carte[table.getn(tab_maj_carte)].rec = tonumber(data)
				elseif (ind_carte == 7) then
					tab_maj_carte[table.getn(tab_maj_carte)].med = tonumber(data)
					ind_carte = 0
				end
			end
		end
	end
	file:close()
	
	if (var == 1) then
		file = io.open("maj/nouveaux_evenements.txt","r")
	else
		file = io.open("maj/evenements.txt","r")
	end
	fin_lecture = false
	
	tab_maj_evt = {}
	ind_evt = 0
	
	while (fin_lecture == false) do
		ind_evt = ind_evt + 1
		data = file:read()
		if (data == "fin") then
			fin_lecture = true
		else
			if (var == 1) then
				if (ind_evt == 1) then
					tab_maj_evt[table.getn(tab_maj_evt)+1] = {}
					tab_maj_evt[table.getn(tab_maj_evt)].t_l = tonumber(data)
				elseif (ind_evt == 2) then
					tab_maj_evt[table.getn(tab_maj_evt)].col = tonumber(data)
				elseif (ind_evt == 3) then
					tab_maj_evt[table.getn(tab_maj_evt)].img = tonumber(data)
				elseif (ind_evt == 4) then
					tab_maj_evt[table.getn(tab_maj_evt)].lig = tonumber(data)
				elseif (ind_evt == 5) then
					tab_maj_evt[table.getn(tab_maj_evt)].t_c = tonumber(data)
				elseif (ind_evt == 6) then
					tab_maj_evt[table.getn(tab_maj_evt)].action = tostring(data)
				elseif (ind_evt == 7) then
					tab_maj_evt[table.getn(tab_maj_evt)].couleur = Color.new(tonumber(string.sub(data,2,4)),tonumber(string.sub(data,6,8)),tonumber(string.sub(data,10,12)))
				elseif (ind_evt == 8) then
					tab_maj_evt[table.getn(tab_maj_evt)].id = tonumber(data)
					ind_evt = 0
				end
			else 
				if (ind_evt == 1) then
					tab_maj_evt[table.getn(tab_maj_evt)+1] = {}
					tab_maj_evt[table.getn(tab_maj_evt)].id = tonumber(data)
				elseif (ind_evt == 2) then
					tab_maj_evt[table.getn(tab_maj_evt)].action = tostring(data)
				elseif (ind_evt == 3) then
					tab_maj_evt[table.getn(tab_maj_evt)].col = tonumber(data)
				elseif (ind_evt == 4) then
					tab_maj_evt[table.getn(tab_maj_evt)].lig = tonumber(data)
				elseif (ind_evt == 5) then
					tab_maj_evt[table.getn(tab_maj_evt)].t_c = tonumber(data)
				elseif (ind_evt == 6) then
					tab_maj_evt[table.getn(tab_maj_evt)].t_l = tonumber(data)
				elseif (ind_evt == 7) then
					tab_maj_evt[table.getn(tab_maj_evt)].img = tonumber(data)
				elseif (ind_evt == 8) then
					tab_maj_evt[table.getn(tab_maj_evt)].couleur = Color.new(tonumber(string.sub(data,2,4)),tonumber(string.sub(data,6,8)),tonumber(string.sub(data,10,12)))
					ind_evt = 0
				end
			end
		end
	
	end
	file:close()
end

--------------- ! Fonction qui ajoute les niveaux (s'il n'y a pas doublon) ! ---------------
function ajouter_fichiers()
	modification = ""
	for i = 1, table.getn(tab_maj_carte) do
		doublon = false
		j = 0
		while (doublon == false) and (j < table.getn(all_maps)) do
			j = j + 1
			if (tab_maj_carte[i].carte == all_maps[j].carte) then
				doublon = true
			end
		end
		if (doublon == false) then
			mem_ind = tab_maj_carte[i].num
			tab_maj_carte[i].num = table.getn(all_maps)+1
			all_maps[table.getn(all_maps)+1] = tab_maj_carte[i]
			for k = 1,table.getn(tab_maj_evt) do
				if (tab_maj_evt[k].id == mem_ind)then
					tab_maj_evt[k].id = table.getn(all_maps)
					all_events[table.getn(all_events)+1] = tab_maj_evt[k]
				end
			end
		else
			if (tab_maj_carte[i].tps ~= all_maps[j].tps) then
				all_maps[j].tps = tab_maj_carte[i].tps
				modification = modification..all_maps[j].num..","
			end
		end
	end
end

--------------- ! Fonction qui sauvegarde tous les niveaux ! ---------------
function sauvegarder_maj(var)
	sauvegarder_partie(var)
	sauvegarde = nil
	sauvegarde = {}
	for i = 1,table.getn(all_events) do
		if (var == 1) then
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].t_l
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].col
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].img
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].lig
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].t_c
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].action
			temp_couleur = all_events[i].couleur:colors()
			rouge = temp_couleur.r
			if (rouge == 0) then
				rouge = "000"
			end
			bleu = temp_couleur.b
			if (bleu == 0) then
				bleu = "000"
			end
			vert = temp_couleur.g
			if (vert == 0) then
				vert = "000"
			end
			sauvegarde[table.getn(sauvegarde) + 1] = tostring("-"..rouge.."-"..vert.."-"..bleu.."-")
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].id
		else
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].id
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].action
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].col
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].lig
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].t_c
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].t_l
			sauvegarde[table.getn(sauvegarde) + 1] = all_events[i].img
			temp_couleur = all_events[i].couleur:colors()
			rouge = temp_couleur.r
			if (rouge == 0) then
				rouge = "000"
			end
			bleu = temp_couleur.b
			if (bleu == 0) then
				bleu = "000"
			end
			vert = temp_couleur.g
			if (vert == 0) then
				vert = "000"
			end
			sauvegarde[table.getn(sauvegarde) + 1] = tostring("-"..rouge.."-"..vert.."-"..bleu.."-")
		end
	end
	if (var == 1) then
		file = io.open("scripts_lua/evenements_principaux.txt","w")
	else
		file = io.open("evenements.txt","w")
	end
	for i = 1,table.getn(sauvegarde) do
		file:write(sauvegarde[i].."\n")
	end
	-- ! On crit la balise de fin ! ---
	file:write("fin")
	file:close()
end

--------------- ! Fonction qui demande confirmation pour tlcharger des nouveaux niveaux ! ---------------
function confir_dl()
	fin_confirm_dl = false
	oldpad = Controls.read()
	rafraichir = true
	selecteur = 1
	background = Image.load("images/autres/background.png")
	while (fin_confirm_dl == false) do
		pad = Controls.read()
		if (rafraichir == true) then
			rafraichir = false
			afficher_menu_option(2)
			Gu.start3d()
			IntraFont.load("flash0:/font/ltn8.pgf", 1)
			IntraFont.print((240 - ((IntraFont.print(240,240,"Etes-vous sr de vouloir tlcharger de nouvelles cartes?",1,0,0) - 240)/2)),200,"Etes-vous sr de vouloir tlcharger de nouveaux niveaux?", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			
			IntraFont.load("flash0:/font/ltn13.pgf", 1)
			IntraFont.print((240 - ((IntraFont.print(240,240,"(Une fois le fichier zip tlcharg, fermez le navigateur.)",1,0,0) - 240)/2)),220,"(Une fois le fichier zip tlcharg, fermez le navigateur.)", 1, IntraFont.color(170,170,170,255),IntraFont.color(0,0,0,255))
			
			if (selecteur == 1) then
				IntraFont.load("flash0:/font/ltn5.pgf", 1)
				IntraFont.print(20,260,"Oui",1,IntraFont.color(255,255,255,255),IntraFont.color(100,100,100,255))
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((460 - (IntraFont.print(0,200,"Non",1,0,0))),260,"Non",1,IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
			else
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print(20,260,"Oui",1,IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
				IntraFont.load("flash0:/font/ltn5.pgf", 1)
				IntraFont.print((460 - (IntraFont.print(0,200,"Non",1,0,0))),260,"Non",1,IntraFont.color(255,255,255,255),IntraFont.color(100,100,100,255))
			end
			Gu.end3d()
			screen.waitVblankStart()
			screen:flip()
			
		end
		
		if (pad:right() and not oldpad:right()) then
			selecteur = 2
			rafraichir = true
		elseif (pad:left() and not oldpad:left()) then
			selecteur = 1
			rafraichir = true
		elseif (pad:cross() and not oldpad:cross()) then
			fin_confirm_dl = true
		elseif (pad:circle() and not oldpad:circle()) then
			fin_confirm_dl = true
			selecteur = 2
		end
		oldpad = pad
	end
	if (selecteur == 1) then
		return(true)
	else
		return(false)
	end
end

--------------- ! Fonction qui annonce si le tlchargement a t effectu ! ---------------
function confirmation_dl(var)
	oldpad = Controls.read()
	fin_conf_dl = false
	rafraichir = true
	background = Image.load("images/autres/background.png")
	while (fin_conf_dl == false) do
		pad = Controls.read()
		if (rafraichir == true) then
			rafraichir = false
			afficher_menu_option(2)
			
			Gu.start3d()
			IntraFont.load("flash0:/font/ltn5.pgf", 1)
			if (var == true) then
				IntraFont.print((240 - ((IntraFont.print(240,30,"Le tlchargement des niveaux s'est bien pass.",1,0,0) - 240)/2)),220,"Le tlchargement des niveaux s'est bien pass.",1,IntraFont.color(255,255,255,255),IntraFont.color(100,100,100,255))
			else
				IntraFont.print((240 - ((IntraFont.print(240,30,"Le tlchargement des niveaux a t annul.",1,0,0) - 240)/2)),220,"Le tlchargement des niveaux a t annul.",1,IntraFont.color(255,255,255,255),IntraFont.color(100,100,100,255))
			end
			IntraFont.load("flash0:/font/ltn13.pgf", 1)
			IntraFont.print((240 - ((IntraFont.print(240,200,"Pressez X pour continuer",1,0,0) - 240)/2)),260,"Pressez X pour continuer",1,IntraFont.color(100,100,100,255),IntraFont.color(100,100,100,0))
			
			Gu.end3d()
			
			screen.waitVblankStart()
			screen:flip()
		end
		if (pad:cross() and not oldpad:cross()) then
			fin_conf_dl = true
			background,oldpad,fin_aff_maj = nil
			mettre_a_jour(1)
		end
		
		oldpad = pad
		
	end
end
------